#ifndef DECKEDITORUI_H
#define DECKEDITORUI_H

#include "DeckEditorUIBase.h"

namespace pitacard { namespace ui {

    class DeckEditorUI : public DeckEditorUIBase
    {
    public:
	DeckEditorUI(QWidget* parent=0,
		     const char* name=0,
		     WFlags fl=WType_TopLevel);

    protected:
	void fileNew();
	void fileOpen();
	void fileSave();
	void fileSaveAs();
	void fileExit();
	
	void deckAddCard();
	void deckRemoveCard();
	void deckAddFolder();
	void deckRemoveFolder();
	void deckReview();
	void deckReviewSubtree();

	void helpAbout();
	
	void setCardFont();
	
	void deckSelectionChanged(QListViewItem* lbi);
	void deckChanged();
	void frontTextChanged();
	void backTextChanged();
	void backXlatorChanged(int);
	void frontXlatorChanged(int);
    
    private:
	bool queryUnsavedChanges();
	
	QString mFilename;
	bool mUnsavedChanges;
    };

} }

#endif
