#include "DeckReviewOptionsDlg.h"

#include "faceChoosers.h"
#include "folder.h"
#include "KeyboardDeckRunnerUI.h"
#include "selectors.h"

#include <qcombobox.h>

#include <iostream>

namespace
{

    enum FaceOrder
    {
	FRONT_FIRST = 0,
	BACK_FIRST = 1
    };

    enum CardOrder
    {
	RANDOM = 0,
	IN_ORDER = 1
    };
    
}

namespace pitacard { namespace ui {

    using namespace pitacard::data;
    
    DeckReviewOptionsDlg::DeckReviewOptionsDlg(const Folder& f,
					       QWidget* parent,
					       const char* name,
					       bool modal,
					       WFlags fl) :
	DeckReviewOptionsDlgBase(parent, name, modal, fl),
	mFolder (&f)
    {}

    void DeckReviewOptionsDlg::start()
    {
	using namespace pitacard::data;
	using namespace pitacard::util;
	
	int faceOrder = mFaceOrderCombo->currentItem();
	int cardOrder = mCardOrderCombo->currentItem();
	
	if (faceOrder == FRONT_FIRST &&
	    cardOrder == RANDOM)
	{
	    KeyboardDeckRunnerUI<RandomSelector, FrontFirst>
		drui(*mFolder, this, "DeckRunnerUI", true);
	    drui.exec();
	}
	else if (faceOrder == FRONT_FIRST &&
		 cardOrder == IN_ORDER)
	{
	    KeyboardDeckRunnerUI<InOrderSelector, FrontFirst>
		drui(*mFolder, this, "DeckRunnerUI", true);
	    drui.exec();
	}
	else if (faceOrder == BACK_FIRST &&
		 cardOrder == RANDOM)
	{
	    KeyboardDeckRunnerUI<RandomSelector, BackFirst>
		drui(*mFolder, this, "DeckRunnerUI", true);
	    drui.exec();
	}
	else if (faceOrder == BACK_FIRST &&
		 cardOrder == IN_ORDER)
	{
	    KeyboardDeckRunnerUI<InOrderSelector, BackFirst>
		drui(*mFolder, this, "DeckRunnerUI", true);
	    drui.exec();
	}
    }
    
} }
