#include "card.h"

#include <iostream>

namespace pitacard { namespace data {

    Card::Face::Face()
    {}
    
    Card::Face::Face(const QString& text) :
	mText (text)
    {}
    
    Card::Card()
    {}

    Card::Card(const QString& name) :
	mName (name)
    {}
    
    Card::Card(const QString& name,
	       const QString& frontText,
	       const QString& backText) :
	mName (name),
	mFront (frontText),
	mBack (backText)
    {}

    void Card::setName(const QString& name)
    { mName = name; }
    
    void Card::setFront(const Face& f)
    { mFront = f; }
    
    void Card::setBack(const Face& f)
    { mBack = f; }

    const QString& Card::name() const
    { return mName; }

    Card::Face& Card::front()
    { return mFront; }
    
    const Card::Face& Card::front() const
    { return mFront; }

    Card::Face& Card::back()
    { return mBack; }
    
    const Card::Face& Card::back() const
    { return mBack; }

    bool operator==(const Card::Face& lhs, const Card::Face& rhs)
    {
      return ( (lhs.mText == rhs.mText) );
    }
    
    bool operator==(const Card& lhs, const Card& rhs)
    {
	return ( (lhs.front() == rhs.front()) &&
		 (lhs.back() == rhs.back()) &&
		 (lhs.name() == rhs.name()) );
    }

    std::ostream& operator<<(std::ostream& os, const Card::Face& f)
    {
	os << "[Face@" << &f << "] " << f.mText.latin1();
    }
    
    std::ostream& operator<<(std::ostream& os, const Card& c)
    {
	os << "[Card@" << &c << "]\n"
	   << "\tName  = " << c.name().latin1() << std::endl
	   << "\tFront = " << c.front() << std::endl
	   << "\tBack  = " << c.back();
    }
    
} }
