#include "selectors.h"

namespace pitacard { namespace util {

    using namespace pitacard::data;

    Cards::const_iterator
    InOrderSelector::nextCard(const Cards& cards,
			      Cards::const_iterator curr)
    {
	if (curr == cards.end())
	    return cards.begin();

	++curr;
	return (curr == cards.end()) ? cards.begin() : curr;
    }
    
    Cards::const_iterator
    RandomSelector::nextCard(const Cards& cards,
			     Cards::const_iterator curr)
    {
	if (cards.size() < 1)
	    return cards.end();
	
	return cards.begin() + (rand() % cards.size());
    }
    
} }
