#include "util.h"

#include <qcombobox.h>
#include <qstring.h>

namespace pitacard { namespace util {

    void setSelectedItem(QComboBox& box,
			 const QString& sz)
    {
	for (int idx = 0; idx < box.count(); ++idx)
	{
	    if (box.text(idx) == sz)
	    {
		box.setCurrentItem(idx);
		return;
	    }
	}
    }

    Qt::Key translateQtKey(const QString& in)
    {
	QString sz = in.stripWhiteSpace();
	
	if (sz == "Key_Escape") return Qt::Key_Escape;
	if (sz == "Key_Tab") return Qt::Key_Tab;
	if (sz == "Key_Backtab") return Qt::Key_Backtab;
	if (sz == "Key_BackTab") return Qt::Key_BackTab;
	if (sz == "Key_Backspace") return Qt::Key_Backspace;
	if (sz == "Key_BackSpace") return Qt::Key_BackSpace;
	if (sz == "Key_Return") return Qt::Key_Return;
	if (sz == "Key_Enter") return Qt::Key_Enter;
	if (sz == "Key_Insert") return Qt::Key_Insert;
	if (sz == "Key_Delete") return Qt::Key_Delete;
	if (sz == "Key_Pause") return Qt::Key_Pause;
	if (sz == "Key_Print") return Qt::Key_Print;
	if (sz == "Key_SysReq") return Qt::Key_SysReq;
	if (sz == "Key_Clear") return Qt::Key_Clear;
	if (sz == "Key_Home") return Qt::Key_Home;
	if (sz == "Key_End") return Qt::Key_End;
	if (sz == "Key_Left") return Qt::Key_Left;
	if (sz == "Key_Up") return Qt::Key_Up;
	if (sz == "Key_Right") return Qt::Key_Right;
	if (sz == "Key_Down") return Qt::Key_Down;
	if (sz == "Key_Prior") return Qt::Key_Prior;
	if (sz == "Key_PageUp") return Qt::Key_PageUp;
	if (sz == "Key_Next") return Qt::Key_Next;
	if (sz == "Key_PageDown") return Qt::Key_PageDown;
	if (sz == "Key_Shift") return Qt::Key_Shift;
	if (sz == "Key_Control") return Qt::Key_Control;
	if (sz == "Key_Meta") return Qt::Key_Meta;
	if (sz == "Key_Alt") return Qt::Key_Alt;
	if (sz == "Key_CapsLock") return Qt::Key_CapsLock;
	if (sz == "Key_NumLock") return Qt::Key_NumLock;
	if (sz == "Key_ScrollLock") return Qt::Key_ScrollLock;
	if (sz == "Key_F1") return Qt::Key_F1;
	if (sz == "Key_F2") return Qt::Key_F2;
	if (sz == "Key_F3") return Qt::Key_F3;
	if (sz == "Key_F4") return Qt::Key_F4;
	if (sz == "Key_F5") return Qt::Key_F5;
	if (sz == "Key_F6") return Qt::Key_F6;
	if (sz == "Key_F7") return Qt::Key_F7;
	if (sz == "Key_F8") return Qt::Key_F8;
	if (sz == "Key_F9") return Qt::Key_F9;
	if (sz == "Key_F10") return Qt::Key_F10;
	if (sz == "Key_F11") return Qt::Key_F11;
	if (sz == "Key_F12") return Qt::Key_F12;
	if (sz == "Key_F13") return Qt::Key_F13;
	if (sz == "Key_F14") return Qt::Key_F14;
	if (sz == "Key_F15") return Qt::Key_F15;
	if (sz == "Key_F16") return Qt::Key_F16;
	if (sz == "Key_F17") return Qt::Key_F17;
	if (sz == "Key_F18") return Qt::Key_F18;
	if (sz == "Key_F19") return Qt::Key_F19;
	if (sz == "Key_F20") return Qt::Key_F20;
	if (sz == "Key_F21") return Qt::Key_F21;
	if (sz == "Key_F22") return Qt::Key_F22;
	if (sz == "Key_F23") return Qt::Key_F23;
	if (sz == "Key_F24") return Qt::Key_F24;
	if (sz == "Key_F25") return Qt::Key_F25;
	if (sz == "Key_F26") return Qt::Key_F26;
	if (sz == "Key_F27") return Qt::Key_F27;
	if (sz == "Key_F28") return Qt::Key_F28;
	if (sz == "Key_F29") return Qt::Key_F29;
	if (sz == "Key_F30") return Qt::Key_F30;
	if (sz == "Key_F31") return Qt::Key_F31;
	if (sz == "Key_F32") return Qt::Key_F32;
	if (sz == "Key_F33") return Qt::Key_F33;
	if (sz == "Key_F34") return Qt::Key_F34;
	if (sz == "Key_F35") return Qt::Key_F35;
	if (sz == "Key_Super_L") return Qt::Key_Super_L;
	if (sz == "Key_Super_R") return Qt::Key_Super_R;
	if (sz == "Key_Menu") return Qt::Key_Menu;
	if (sz == "Key_Hyper_L") return Qt::Key_Hyper_L;
	if (sz == "Key_Hyper_R") return Qt::Key_Hyper_R;
	if (sz == "Key_Help") return Qt::Key_Help;
	if (sz == "Key_Direction_L") return Qt::Key_Direction_L;
	if (sz == "Key_Direction_R") return Qt::Key_Direction_R;
	if (sz == "Key_Space") return Qt::Key_Space;
	if (sz == "Key_Any") return Qt::Key_Any;
	if (sz == "Key_Exclam") return Qt::Key_Exclam;
	if (sz == "Key_QuoteDbl") return Qt::Key_QuoteDbl;
	if (sz == "Key_NumberSign") return Qt::Key_NumberSign;
	if (sz == "Key_Dollar") return Qt::Key_Dollar;
	if (sz == "Key_Percent") return Qt::Key_Percent;
	if (sz == "Key_Ampersand") return Qt::Key_Ampersand;
	if (sz == "Key_Apostrophe") return Qt::Key_Apostrophe;
	if (sz == "Key_ParenLeft") return Qt::Key_ParenLeft;
	if (sz == "Key_ParenRight") return Qt::Key_ParenRight;
	if (sz == "Key_Asterisk") return Qt::Key_Asterisk;
	if (sz == "Key_Plus") return Qt::Key_Plus;
	if (sz == "Key_Comma") return Qt::Key_Comma;
	if (sz == "Key_Minus") return Qt::Key_Minus;
	if (sz == "Key_Period") return Qt::Key_Period;
	if (sz == "Key_Slash") return Qt::Key_Slash;
	if (sz == "Key_0") return Qt::Key_0;
	if (sz == "Key_1") return Qt::Key_1;
	if (sz == "Key_2") return Qt::Key_2;
	if (sz == "Key_3") return Qt::Key_3;
	if (sz == "Key_4") return Qt::Key_4;
	if (sz == "Key_5") return Qt::Key_5;
	if (sz == "Key_6") return Qt::Key_6;
	if (sz == "Key_7") return Qt::Key_7;
	if (sz == "Key_8") return Qt::Key_8;
	if (sz == "Key_9") return Qt::Key_9;
	if (sz == "Key_Colon") return Qt::Key_Colon;
	if (sz == "Key_Semicolon") return Qt::Key_Semicolon;
	if (sz == "Key_Less") return Qt::Key_Less;
	if (sz == "Key_Equal") return Qt::Key_Equal;
	if (sz == "Key_Greater") return Qt::Key_Greater;
	if (sz == "Key_Question") return Qt::Key_Question;
	if (sz == "Key_At") return Qt::Key_At;
	if (sz == "Key_A") return Qt::Key_A;
	if (sz == "Key_B") return Qt::Key_B;
	if (sz == "Key_C") return Qt::Key_C;
	if (sz == "Key_D") return Qt::Key_D;
	if (sz == "Key_E") return Qt::Key_E;
	if (sz == "Key_F") return Qt::Key_F;
	if (sz == "Key_G") return Qt::Key_G;
	if (sz == "Key_H") return Qt::Key_H;
	if (sz == "Key_I") return Qt::Key_I;
	if (sz == "Key_J") return Qt::Key_J;
	if (sz == "Key_K") return Qt::Key_K;
	if (sz == "Key_L") return Qt::Key_L;
	if (sz == "Key_M") return Qt::Key_M;
	if (sz == "Key_N") return Qt::Key_N;
	if (sz == "Key_O") return Qt::Key_O;
	if (sz == "Key_P") return Qt::Key_P;
	if (sz == "Key_Q") return Qt::Key_Q;
	if (sz == "Key_R") return Qt::Key_R;
	if (sz == "Key_S") return Qt::Key_S;
	if (sz == "Key_T") return Qt::Key_T;
	if (sz == "Key_U") return Qt::Key_U;
	if (sz == "Key_V") return Qt::Key_V;
	if (sz == "Key_W") return Qt::Key_W;
	if (sz == "Key_X") return Qt::Key_X;
	if (sz == "Key_Y") return Qt::Key_Y;
	if (sz == "Key_Z") return Qt::Key_Z;
	if (sz == "Key_BracketLeft") return Qt::Key_BracketLeft;
	if (sz == "Key_Backslash") return Qt::Key_Backslash;
	if (sz == "Key_BracketRight") return Qt::Key_BracketRight;
	if (sz == "Key_AsciiCircum") return Qt::Key_AsciiCircum;
	if (sz == "Key_Underscore") return Qt::Key_Underscore;
	if (sz == "Key_QuoteLeft") return Qt::Key_QuoteLeft;
	if (sz == "Key_BraceLeft") return Qt::Key_BraceLeft;
	if (sz == "Key_Bar") return Qt::Key_Bar;
	if (sz == "Key_BraceRight") return Qt::Key_BraceRight;
	if (sz == "Key_AsciiTilde") return Qt::Key_AsciiTilde;
	if (sz == "Key_nobreakspace") return Qt::Key_nobreakspace;
	if (sz == "Key_exclamdown") return Qt::Key_exclamdown;
	if (sz == "Key_cent") return Qt::Key_cent;
	if (sz == "Key_sterling") return Qt::Key_sterling;
	if (sz == "Key_currency") return Qt::Key_currency;
	if (sz == "Key_yen") return Qt::Key_yen;
	if (sz == "Key_brokenbar") return Qt::Key_brokenbar;
	if (sz == "Key_section") return Qt::Key_section;
	if (sz == "Key_diaeresis") return Qt::Key_diaeresis;
	if (sz == "Key_copyright") return Qt::Key_copyright;
	if (sz == "Key_ordfeminine") return Qt::Key_ordfeminine;
	if (sz == "Key_guillemotleft") return Qt::Key_guillemotleft;
	if (sz == "Key_notsign") return Qt::Key_notsign;
	if (sz == "Key_hyphen") return Qt::Key_hyphen;
	if (sz == "Key_registered") return Qt::Key_registered;
	if (sz == "Key_macron") return Qt::Key_macron;
	if (sz == "Key_degree") return Qt::Key_degree;
	if (sz == "Key_plusminus") return Qt::Key_plusminus;
	if (sz == "Key_twosuperior") return Qt::Key_twosuperior;
	if (sz == "Key_threesuperior") return Qt::Key_threesuperior;
	if (sz == "Key_acute") return Qt::Key_acute;
	if (sz == "Key_mu") return Qt::Key_mu;
	if (sz == "Key_paragraph") return Qt::Key_paragraph;
	if (sz == "Key_periodcentered") return Qt::Key_periodcentered;
	if (sz == "Key_cedilla") return Qt::Key_cedilla;
	if (sz == "Key_onesuperior") return Qt::Key_onesuperior;
	if (sz == "Key_masculine") return Qt::Key_masculine;
	if (sz == "Key_guillemotright") return Qt::Key_guillemotright;
	if (sz == "Key_onequarter") return Qt::Key_onequarter;
	if (sz == "Key_onehalf") return Qt::Key_onehalf;
	if (sz == "Key_threequarters") return Qt::Key_threequarters;
	if (sz == "Key_questiondown") return Qt::Key_questiondown;
	if (sz == "Key_Agrave") return Qt::Key_Agrave;
	if (sz == "Key_Aacute") return Qt::Key_Aacute;
	if (sz == "Key_Acircumflex") return Qt::Key_Acircumflex;
	if (sz == "Key_Atilde") return Qt::Key_Atilde;
	if (sz == "Key_Adiaeresis") return Qt::Key_Adiaeresis;
	if (sz == "Key_Aring") return Qt::Key_Aring;
	if (sz == "Key_AE") return Qt::Key_AE;
	if (sz == "Key_Ccedilla") return Qt::Key_Ccedilla;
	if (sz == "Key_Egrave") return Qt::Key_Egrave;
	if (sz == "Key_Eacute") return Qt::Key_Eacute;
	if (sz == "Key_Ecircumflex") return Qt::Key_Ecircumflex;
	if (sz == "Key_Ediaeresis") return Qt::Key_Ediaeresis;
	if (sz == "Key_Igrave") return Qt::Key_Igrave;
	if (sz == "Key_Iacute") return Qt::Key_Iacute;
	if (sz == "Key_Icircumflex") return Qt::Key_Icircumflex;
	if (sz == "Key_Idiaeresis") return Qt::Key_Idiaeresis;
	if (sz == "Key_ETH") return Qt::Key_ETH;
	if (sz == "Key_Ntilde") return Qt::Key_Ntilde;
	if (sz == "Key_Ograve") return Qt::Key_Ograve;
	if (sz == "Key_Oacute") return Qt::Key_Oacute;
	if (sz == "Key_Ocircumflex") return Qt::Key_Ocircumflex;
	if (sz == "Key_Otilde") return Qt::Key_Otilde;
	if (sz == "Key_Odiaeresis") return Qt::Key_Odiaeresis;
	if (sz == "Key_multiply") return Qt::Key_multiply;
	if (sz == "Key_Ooblique") return Qt::Key_Ooblique;
	if (sz == "Key_Ugrave") return Qt::Key_Ugrave;
	if (sz == "Key_Uacute") return Qt::Key_Uacute;
	if (sz == "Key_Ucircumflex") return Qt::Key_Ucircumflex;
	if (sz == "Key_Udiaeresis") return Qt::Key_Udiaeresis;
	if (sz == "Key_Yacute") return Qt::Key_Yacute;
	if (sz == "Key_THORN") return Qt::Key_THORN;
	if (sz == "Key_ssharp") return Qt::Key_ssharp;
	if (sz == "Key_agrave") return Qt::Key_agrave;
	if (sz == "Key_aacute") return Qt::Key_aacute;
	if (sz == "Key_acircumflex") return Qt::Key_acircumflex;
	if (sz == "Key_atilde") return Qt::Key_atilde;
	if (sz == "Key_adiaeresis") return Qt::Key_adiaeresis;
	if (sz == "Key_aring") return Qt::Key_aring;
	if (sz == "Key_ae") return Qt::Key_ae;
	if (sz == "Key_ccedilla") return Qt::Key_ccedilla;
	if (sz == "Key_egrave") return Qt::Key_egrave;
	if (sz == "Key_eacute") return Qt::Key_eacute;
	if (sz == "Key_ecircumflex") return Qt::Key_ecircumflex;
	if (sz == "Key_ediaeresis") return Qt::Key_ediaeresis;
	if (sz == "Key_igrave") return Qt::Key_igrave;
	if (sz == "Key_iacute") return Qt::Key_iacute;
	if (sz == "Key_icircumflex") return Qt::Key_icircumflex;
	if (sz == "Key_idiaeresis") return Qt::Key_idiaeresis;
	if (sz == "Key_eth") return Qt::Key_eth;
	if (sz == "Key_ntilde") return Qt::Key_ntilde;
	if (sz == "Key_ograve") return Qt::Key_ograve;
	if (sz == "Key_oacute") return Qt::Key_oacute;
	if (sz == "Key_ocircumflex") return Qt::Key_ocircumflex;
	if (sz == "Key_otilde") return Qt::Key_otilde;
	if (sz == "Key_odiaeresis") return Qt::Key_odiaeresis;
	if (sz == "Key_division") return Qt::Key_division;
	if (sz == "Key_oslash") return Qt::Key_oslash;
	if (sz == "Key_ugrave") return Qt::Key_ugrave;
	if (sz == "Key_uacute") return Qt::Key_uacute;
	if (sz == "Key_ucircumflex") return Qt::Key_ucircumflex;
	if (sz == "Key_udiaeresis") return Qt::Key_udiaeresis;
	if (sz == "Key_yacute") return Qt::Key_yacute;
	if (sz == "Key_thorn") return Qt::Key_thorn;
	if (sz == "Key_ydiaeresis") return Qt::Key_ydiaeresis;
	if (sz == "Key_Back") return Qt::Key_Back;
	if (sz == "Key_Forward") return Qt::Key_Forward;
	if (sz == "Key_Stop") return Qt::Key_Stop;
	if (sz == "Key_Refresh") return Qt::Key_Refresh;
	if (sz == "Key_VolumeDown") return Qt::Key_VolumeDown;
	if (sz == "Key_VolumeMute") return Qt::Key_VolumeMute;
	if (sz == "Key_VolumeUp") return Qt::Key_VolumeUp;
	if (sz == "Key_BassBoost") return Qt::Key_BassBoost;
	if (sz == "Key_BassUp") return Qt::Key_BassUp;
	if (sz == "Key_BassDown") return Qt::Key_BassDown;
	if (sz == "Key_TrebleUp") return Qt::Key_TrebleUp;
	if (sz == "Key_TrebleDown") return Qt::Key_TrebleDown;
	if (sz == "Key_MediaPlay") return Qt::Key_MediaPlay;
	if (sz == "Key_MediaStop") return Qt::Key_MediaStop;
	if (sz == "Key_MediaPrev") return Qt::Key_MediaPrev;
	if (sz == "Key_MediaNext") return Qt::Key_MediaNext;
	if (sz == "Key_MediaRecord") return Qt::Key_MediaRecord;
	if (sz == "Key_HomePage") return Qt::Key_HomePage;
	if (sz == "Key_Favorites") return Qt::Key_Favorites;
	if (sz == "Key_Search") return Qt::Key_Search;
	if (sz == "Key_Standby") return Qt::Key_Standby;
	if (sz == "Key_OpenUrl") return Qt::Key_OpenUrl;
	if (sz == "Key_LaunchMail") return Qt::Key_LaunchMail;
	if (sz == "Key_LaunchMedia") return Qt::Key_LaunchMedia;
	if (sz == "Key_Launch0") return Qt::Key_Launch0;
	if (sz == "Key_Launch1") return Qt::Key_Launch1;
	if (sz == "Key_Launch2") return Qt::Key_Launch2;
	if (sz == "Key_Launch3") return Qt::Key_Launch3;
	if (sz == "Key_Launch4") return Qt::Key_Launch4;
	if (sz == "Key_Launch5") return Qt::Key_Launch5;
	if (sz == "Key_Launch6") return Qt::Key_Launch6;
	if (sz == "Key_Launch7") return Qt::Key_Launch7;
	if (sz == "Key_Launch8") return Qt::Key_Launch8;
	if (sz == "Key_Launch9") return Qt::Key_Launch9;
	if (sz == "Key_LaunchA") return Qt::Key_LaunchA;
	if (sz == "Key_LaunchB") return Qt::Key_LaunchB;
	if (sz == "Key_LaunchC") return Qt::Key_LaunchC;
	if (sz == "Key_LaunchD") return Qt::Key_LaunchD;
	if (sz == "Key_LaunchE") return Qt::Key_LaunchE;
	if (sz == "Key_LaunchF") return Qt::Key_LaunchF;
	if (sz == "Key_MediaLast") return Qt::Key_MediaLast;
	if (sz == "Key_unknown") return Qt::Key_unknown;

	throw QString("Unknown key: ") + in;
    }
    
    Qt::ButtonState translateQtButton(const QString& in)
    {
	QString sz = in.stripWhiteSpace();
	
	if (sz == "NoButton") return Qt::NoButton;
	if (sz == "LeftButton") return Qt::LeftButton;
	if (sz == "RightButton") return Qt::RightButton;
	if (sz == "MidButton") return Qt::MidButton;
	if (sz == "MouseButtonMask") return Qt::MouseButtonMask;
	if (sz == "ShiftButton") return Qt::ShiftButton;
	if (sz == "ControlButton") return Qt::ControlButton;
	if (sz == "AltButton") return Qt::AltButton;
	if (sz == "MetaButton") return Qt::MetaButton;
	if (sz == "KeyButtonMask") return Qt::KeyButtonMask;
	if (sz == "Keypad") return Qt::Keypad;

	throw QString("Unknown modifier: ") + in;
    }
    
    QChar translateUnicodeChar(const QString& sz)
    {
	bool ok = true;
	QString stripped = sz.stripWhiteSpace();
	QChar rval(stripped.right(stripped.length() - 2).toInt(&ok, 16));
	if (!ok)
	    throw QString("Unable to translate to unicode: ") + sz;
	return rval;
    }
    
} }
