#ifndef UTIL_H
#define UTIL_H

class QComboBox;

#include <qnamespace.h>
#include <qstring.h>

namespace pitacard { namespace util {

    /** selects the first item in the combobox that matches
	'sz' */
    void setSelectedItem(QComboBox& box,
			 const QString& sz);

    /* The following throw a QString if they can't translate the input */
    Qt::Key translateQtKey(const QString& sz);
    Qt::ButtonState translateQtButton(const QString& sz);

    /** translates a string of the form "0xFFFF" to a unicode character */
    QChar translateUnicodeChar(const QString& sz);
    
} }

#endif
