#ifndef XLATTEXTEDIT_H
#define XLATTEXTEDIT_H

#include "keyTranslator.h"

#include <qtextedit.h>

namespace pitacard { namespace ui {

    using namespace pitacard::xlat;
    
    class XlatTextEdit : public QTextEdit
    {
    public:
	XlatTextEdit(const QString& text,
		     const QString& context=QString::null,
		     QWidget* parent=0,
		     const char* name=0);

	XlatTextEdit(QWidget* parent=0,
		     const char* name=0);

	void setKeyTranslator(const KeyTranslator& kt);
	
    protected:
	void keyPressEvent(QKeyEvent* e);
	void focusInEvent(QFocusEvent* e);
	void focusOutEvent(QFocusEvent* e);
	
    private:
	KeyTranslator mXlat;
    };
    
} }

#endif
